// GENERATED CODE - edits may be overwritten
import java.io.IOException;
import java.net.Socket;

import dk.vajhoej.record.VAXFloatUtil;
import dk.vajhoej.vms.tig.server.ServerSingleThreaded;
import dk.vajhoej.vms.tig.shared.Connection;

import static dk.vajhoej.vms.call.VMS.*;

public class DemopServer extends ServerSingleThreaded {
    @Override
    public int getPort() {
        return 12346;
    }
    @Override
    public void process(Socket s) throws IOException {
        Connection con = new Connection(s);
        con.recv();
        String target = con.getString();
        if(target.equals("add")) {
            int a = con.getInt();
            int b = con.getInt();
            int res;
            LongWord awrap = new LongWord(a);
            LongWord bwrap = new LongWord(b);
            LongWord reswrap = new LongWord();
            int retval = call("demop", "add"
                                     , pass(awrap).byReference().readOnly()
                                     , pass(bwrap).byReference().readOnly()
                                     , pass(reswrap).byReference().writeOnly()
                             );
            res = reswrap.getValue();
            con.prep();
            con.putInt(retval);
            con.putInt(res);
        }
        if(target.equals("conc")) {
            String a = con.getString();
            String b = con.getString();
            String res;
            VariableCharacterString awrap = new VariableCharacterString(a);
            VariableCharacterString bwrap = new VariableCharacterString(b);
            VariableCharacterString reswrap = new VariableCharacterString(32000);
            int retval = call("demop", "conc"
                                     , pass(awrap).byReference().readOnly()
                                     , pass(bwrap).byReference().readOnly()
                                     , pass(reswrap).byReference().writeOnly()
                             );
            res = reswrap.toString();
            con.prep();
            con.putInt(retval);
            con.putString(res);
        }
        if(target.equals("modify")) {
            byte[] o = con.getBytes();
            ByteBuffer owrap = new ByteBuffer(o);
            int retval = call("demop", "modify"
                                     , pass(owrap).byReference().readWrite()
                             );
            o = owrap.getValue();
            con.prep();
            con.putInt(retval);
            con.putBytes(o);
        }
        if(target.equals("getid")) {
            String res;
            VariableCharacterString reswrap = new VariableCharacterString(32000);
            int retval = call("demop", "getid"
                                     , pass(reswrap).byReference().writeOnly()
                             );
            res = reswrap.toString();
            con.prep();
            con.putInt(retval);
            con.putString(res);
        }
        con.send();
    }
    public static void main(String[] args) throws IOException {
         (new DemopServer()).run();
    }
}
